% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 4 MATLAB codes %%%
%%% Figures 4.2 and 4.3%%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
load SamplingSeismicData

%Displaying the data in wiggle 
scale=2;
figure,mwigb(Dshot,scale,offset,t)
xlabel('Offset (m)','FontName','Times','FontSize',14)
ylabel('Time (s)','FontName','Times','FontSize',14)
set(gcf,'PaperPositionMode','auto')



%no down-sampling
g=Dshot(:,1);
[nt,nx]=size(Dshot);
%Single trace plot
figure,plot(t,g,'k','LineWidth',2)
xlabel('{\it t}(s)','FontName','Times','FontSize',14)
ylabel('{\it g}({\itt})','FontName','Times','FontSize',14)
set(gcf,'PaperPositionMode','auto')

f=linspace(-0.5,0.5,3*nt)/dt;
magG=abs(fftshift(fft(g,3*nt)));
figure,plot(f,magG/max(magG),'k','LineWidth',2)
xlabel('{\itf} (Hz)','FontName','Times','FontSize',14)
ylabel('|{\it G}({\it e^{\it jf}})|','FontName','Times','FontSize',14)
axis([min(f),max(f),0,1.05])%Diplaying +ve frequencies
set(gcf,'PaperPositionMode','auto')


%downsampling sampling by 2
sub_samp=4;
g=Dshot(1:sub_samp:nt,1);
ts=t(1:sub_samp:nt);
dts=dt*sub_samp;
[nt,nx]=size(Dshot);
%Single trace plot
figure,plot(ts,g,'k','LineWidth',2)
xlabel('{\it t}(s)','FontName','Times','FontSize',14)
ylabel('{\it g}({\itt})','FontName','Times','FontSize',14)
set(gcf,'PaperPositionMode','auto')

f=linspace(-0.5,0.5,3*nt)/dts;
magG=abs(fftshift(fft(g,3*nt)));
figure,plot(f,magG/max(magG),'k','LineWidth',2)
xlabel('{\itf} (Hz)','FontName','Times','FontSize',14)
ylabel('|{\it G}({\it e^{\it jf}})|','FontName','Times','FontSize',14)
axis([min(f),max(f),0,1.05])%Diplaying +ve frequencies
set(gcf,'PaperPositionMode','auto')

%Displaying the data in wiggle 
scale=2;
figure,mwigb(Dshot(1:sub_samp:nt,:),scale,offset,ts)
xlabel('Offset (m)','FontName','Times','FontSize',14)
ylabel('Time (s)','FontName','Times','FontSize',14)
set(gcf,'PaperPositionMode','auto')



%downsampling sampling by 4
sub_samp=8;
g=Dshot(1:sub_samp:nt,1);
ts=t(1:sub_samp:nt);
dts=dt*sub_samp;
[nt,nx]=size(Dshot);
%Single trace plot
figure,plot(ts,g,'k','LineWidth',2)
xlabel('{\it t}(s)','FontName','Times','FontSize',14)
ylabel('{\it g}({\itt})','FontName','Times','FontSize',14)
set(gcf,'PaperPositionMode','auto')

f=linspace(-0.5,0.5,3*nt)/dts;
magG=abs(fftshift(fft(g,3*nt)));
figure,plot(f,magG/max(magG),'k','LineWidth',2)
xlabel('{\itf} (Hz)','FontName','Times','FontSize',14)
ylabel('|{\it G}({\it e^{\it jf}})|','FontName','Times','FontSize',14)
axis([min(f),max(f),0,1.05])%Diplaying +ve frequencies
set(gcf,'PaperPositionMode','auto')

%Displaying the data in wiggle 
scale=2;
figure,mwigb(Dshot(1:sub_samp:nt,:),scale,offset,ts)
xlabel('Offset (m)','FontName','Times','FontSize',14)
ylabel('Time (s)','FontName','Times','FontSize',14)
set(gcf,'PaperPositionMode','auto')
%print -f9 -depsc2 -zbuffer -r300 Ch04_fig_subs_sg_c


