% This code if for the book titled: Advanced Digital Signal Processing 
% of Seismic Data by Wail A. Mousa 
% January 1, 2020.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Chapter 4 MATLAB codes %%%
%%% Figure 4.7 Many frequencies case%%
clear,clc,close all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%a

nt=501;
nx=30;

dx=10;
dt=2E-3;
F=10:0.5:50;
t=[0:nt-1]*dt;
x=[0:nx-1]*dx;
dip=6E-3;
v=dx/dip
Kx=F/v;

seis=zeros(nt,nx);
for i=1:length(F)
        seis=seis+disturbance_fn(Kx(i),F(i),x,t,nt,nx);
end




figure,mwigb(seis,2,x,t)
xlabel('Offset (m)','FontName','Times','FontSize',14)
ylabel('Time (s)','FontName','Times','FontSize',14)
set(gcf,'PaperPositionMode','auto')


[seis_fk,f,kx]=fk(seis,dt,dx);
f=f(length(f):-1:1);
seis_fk=fftshift(seis_fk);
figure,imagesc(kx,f,abs(seis_fk)),colormap(sgray)
axis([min(kx),max(kx),0,2*max(F)])
xlabel('$\grave{k}$ (1/m)','Interpreter','latex','FontSize',14)
ylabel('$f$ (Hz)','Interpreter','latex','FontSize',14)
x=10;y=10;%starting screen position
w=300;%figure width
h=600;%figure hieght
set(gcf,'position',[x y w h]);
% Putting the spatial axis in the top of the figure 
set(gca,'xaxislocation','top')
set(gcf,'PaperPositionMode','auto')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%b
nt=501;
nx=30;

dx=10;
dt=2E-3;
F=10:0.5:50;
t=[0:nt-1]*dt;
x=[0:nx-1]*dx;
dip=12E-3;
v=dx/dip
Kx=F/v;

seis=zeros(nt,nx);
for i=1:length(F)
        seis=seis+disturbance_fn(Kx(i),F(i),x,t,nt,nx);
end




figure,mwigb(seis,2,x,t)
xlabel('Offset (m)','FontName','Times','FontSize',14)
ylabel('Time (s)','FontName','Times','FontSize',14)
set(gcf,'PaperPositionMode','auto')


[seis_fk,f,kx]=fk(seis,dt,dx);
f=f(length(f):-1:1);
seis_fk=fftshift(seis_fk);
figure,imagesc(kx,f,abs(seis_fk)),colormap(sgray)
axis([min(kx),max(kx),0,2*max(F)])
xlabel('$\grave{k}$ (1/m)','Interpreter','latex','FontSize',14)
ylabel('$f$ (Hz)','Interpreter','latex','FontSize',14)
x=10;y=10;%starting screen position
w=300;%figure width
h=600;%figure hieght
set(gcf,'position',[x y w h]);
% Putting the spatial axis in the top of the figure 
set(gca,'xaxislocation','top')
set(gcf,'PaperPositionMode','auto')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%c
nt=501;
nx=30;

dx=10;
dt=2E-3;
F=10:0.5:50;
t=[0:nt-1]*dt;
x=[0:nx-1]*dx;
dip=18E-3;
v=dx/dip
Kx=F/v;

seis=zeros(nt,nx);
for i=1:length(F)
        seis=seis+disturbance_fn(Kx(i),F(i),x,t,nt,nx);
end




figure,mwigb(seis,2,x,t)
xlabel('Offset (m)','FontName','Times','FontSize',14)
ylabel('Time (s)','FontName','Times','FontSize',14)
set(gcf,'PaperPositionMode','auto')


[seis_fk,f,kx]=fk(seis,dt,dx);
f=f(length(f):-1:1);
seis_fk=fftshift(seis_fk);
figure,imagesc(kx,f,abs(seis_fk)),colormap(sgray)
axis([min(kx),max(kx),0,2*max(F)])
xlabel('$\grave{k}$ (1/m)','Interpreter','latex','FontSize',14)
ylabel('$f$ (Hz)','Interpreter','latex','FontSize',14)
x=10;y=10;%starting screen position
w=300;%figure width
h=600;%figure hieght
set(gcf,'position',[x y w h]);
% Putting the spatial axis in the top of the figure 
set(gca,'xaxislocation','top')
set(gcf,'PaperPositionMode','auto')


